Index: branches/SHM-dev/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- branches/SHM-dev/source/Lib/TLibCommon/TComDataCU.cpp	(revision 1572)
+++ branches/SHM-dev/source/Lib/TLibCommon/TComDataCU.cpp	(revision 1573)
@@ -96,5 +96,4 @@
   for(UInt i=0; i<NUM_REF_PIC_LIST_01; i++)
   {
-    m_apcCUColocated[i]  = NULL;
     m_apiMVPIdx[i]       = NULL;
     m_apiMVPNum[i]       = NULL;
@@ -209,9 +208,4 @@
   m_pCtuAbove          = NULL;
   m_pCtuLeft           = NULL;
-
-  for(UInt i=0; i<NUM_REF_PIC_LIST_01; i++)
-  {
-    m_apcCUColocated[i]  = NULL;
-  }
 }
 
@@ -376,10 +370,4 @@
   m_pCtuAbove          = NULL;
   m_pCtuLeft           = NULL;
-
-
-  for(UInt i=0; i<NUM_REF_PIC_LIST_01; i++)
-  {
-    m_apcCUColocated[i]  = NULL;
-  }
 
 }
@@ -454,4 +442,5 @@
 
   memset( m_skipFlag          , false,                      m_uiNumPartition * sizeof( *m_skipFlag ) );
+
   memset( m_pePartSize        , NUMBER_OF_PART_SIZES,       m_uiNumPartition * sizeof( *m_pePartSize ) );
   memset( m_pePredMode        , NUMBER_OF_PREDICTION_MODES, m_uiNumPartition * sizeof( *m_pePredMode ) );
@@ -506,10 +495,4 @@
   m_pCtuAboveRight  = NULL;
 
-
-  for(UInt i=0; i<NUM_REF_PIC_LIST_01; i++)
-  {
-    m_apcCUColocated[i]  = NULL;
-  }
-
   UInt frameWidthInCtus = pcPic->getFrameWidthInCtus();
   if ( m_ctuRsAddr % frameWidthInCtus )
@@ -531,13 +514,4 @@
   {
     m_pCtuAboveRight = pcPic->getCtu( m_ctuRsAddr - frameWidthInCtus + 1 );
-  }
-
-  for(UInt i=0; i<NUM_REF_PIC_LIST_01; i++)
-  {
-    const RefPicList rpl=RefPicList(i);
-    if ( getSlice()->getNumRefIdx( rpl ) > 0 )
-    {
-      m_apcCUColocated[rpl] = getSlice()->getRefPic( rpl, 0)->getCtu( m_ctuRsAddr );
-    }
   }
 }
@@ -710,9 +684,4 @@
   m_pCtuAboveLeft   = pcCU->getCtuAboveLeft();
   m_pCtuAboveRight  = pcCU->getCtuAboveRight();
-
-  for(UInt i=0; i<NUM_REF_PIC_LIST_01; i++)
-  {
-    m_apcCUColocated[i] = pcCU->getCUColocated(RefPicList(i));
-  }
 }
 
@@ -786,5 +755,4 @@
   {
     const RefPicList rpl=RefPicList(i);
-    m_apcCUColocated[rpl] = pcCU->getCUColocated(rpl);
     m_apiMVPIdx[rpl]=pcCU->getMVPIdx(rpl)  + uiPart;
     m_apiMVPNum[rpl]=pcCU->getMVPNum(rpl)  + uiPart;
@@ -831,9 +799,4 @@
   m_pCtuAbove          = pcCU->getCtuAbove();
   m_pCtuLeft           = pcCU->getCtuLeft();
-
-  for(UInt i=0; i<NUM_REF_PIC_LIST_01; i++)
-  {
-    m_apcCUColocated[i]  = pcCU->getCUColocated(RefPicList(i));
-  }
 
   m_skipFlag           = pcCU->getSkipFlag ()             + uiAbsPartIdx;
@@ -918,5 +881,4 @@
     memcpy( m_apiMVPIdx[rpl] + uiOffset, pcCU->getMVPIdx(rpl), iSizeInUchar );
     memcpy( m_apiMVPNum[rpl] + uiOffset, pcCU->getMVPNum(rpl), iSizeInUchar );
-    m_apcCUColocated[rpl] = pcCU->getCUColocated(rpl);
   }
 
@@ -2711,5 +2673,4 @@
     absPartIdx = g_auiZscanToRaster[partIdxRB];
     Int ctuRsAddr = -1;
-
     if (  ( ( m_pcPic->getCtu(m_ctuRsAddr)->getCUPelX() + g_auiRasterToPelX[absPartIdx] + m_pcPic->getMinCUWidth () ) < m_pcSlice->getSPS()->getPicWidthInLumaSamples () )  // image boundary check
        && ( ( m_pcPic->getCtu(m_ctuRsAddr)->getCUPelY() + g_auiRasterToPelY[absPartIdx] + m_pcPic->getMinCUHeight() ) < m_pcSlice->getSPS()->getPicHeightInLumaSamples() ) )
Index: branches/SHM-dev/source/Lib/TLibCommon/TComDataCU.h
===================================================================
--- branches/SHM-dev/source/Lib/TLibCommon/TComDataCU.h	(revision 1572)
+++ branches/SHM-dev/source/Lib/TLibCommon/TComDataCU.h	(revision 1573)
@@ -125,5 +125,4 @@
   TComDataCU*   m_pCtuAbove;                            ///< pointer of above CTU.
   TComDataCU*   m_pCtuLeft;                             ///< pointer of left CTU
-  TComDataCU*   m_apcCUColocated[NUM_REF_PIC_LIST_01];  ///< pointer of temporally colocated CU's for both directions
   TComMvField   m_cMvFieldA;                            ///< motion vector of position A
   TComMvField   m_cMvFieldB;                            ///< motion vector of position B
@@ -399,5 +398,4 @@
   TComDataCU*   getCtuAboveLeft               ( )                                                          { return m_pCtuAboveLeft;                    }
   TComDataCU*   getCtuAboveRight              ( )                                                          { return m_pCtuAboveRight;                   }
-  TComDataCU*   getCUColocated                ( RefPicList eRefPicList )                                   { return m_apcCUColocated[eRefPicList];      }
   Bool          CUIsFromSameSlice             ( const TComDataCU *pCU /* Can be NULL */ ) const            { return ( pCU!=NULL && pCU->getSlice()->getSliceCurStartCtuTsAddr() == getSlice()->getSliceCurStartCtuTsAddr() ); }
   Bool          CUIsFromSameTile              ( const TComDataCU *pCU /* Can be NULL */ ) const;