Index: branches/SHM-dev/cfg/per-sequence-svc/Kimono-1.5x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/Kimono-1.5x.cfg	(revision 1032)
+++ branches/SHM-dev/cfg/per-sequence-svc/Kimono-1.5x.cfg	(revision 1581)
@@ -13,5 +13,5 @@
 SourceHeight0                 : 720         # Input  frame height
 RepFormatIdx0                 : 0           # Index of corresponding rep_format() in the VPS
-IntraPeriod0                  : 24          # Period of I-Frame ( -1 = only first)
+IntraPeriod0                  : 32          # Period of I-Frame ( -1 = only first)
 ConformanceMode0              : 1           # conformance mode
 QP0                           : 22
@@ -24,5 +24,5 @@
 SourceHeight1                 : 1080        # Input  frame height
 RepFormatIdx1                 : 1           # Index of corresponding rep_format() in the VPS
-IntraPeriod1                  : 24          # Period of I-Frame ( -1 = only first)
+IntraPeriod1                  : 32          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
 QP1                           : 20
Index: branches/SHM-dev/cfg/per-sequence-svc/Kimono-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/Kimono-2x.cfg	(revision 1032)
+++ branches/SHM-dev/cfg/per-sequence-svc/Kimono-2x.cfg	(revision 1581)
@@ -13,5 +13,5 @@
 SourceHeight0                 : 540         # Input  frame height
 RepFormatIdx0                 : 0           # Index of corresponding rep_format() in the VPS
-IntraPeriod0                  : 24          # Period of I-Frame ( -1 = only first)
+IntraPeriod0                  : 32          # Period of I-Frame ( -1 = only first)
 ConformanceMode0              : 1           # conformance mode
 QP0                           : 22
@@ -24,5 +24,5 @@
 SourceHeight1                 : 1080        # Input  frame height
 RepFormatIdx1                 : 1           # Index of corresponding rep_format() in the VPS
-IntraPeriod1                  : 24          # Period of I-Frame ( -1 = only first)
+IntraPeriod1                  : 32          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
 QP1                           : 20
Index: branches/SHM-dev/cfg/per-sequence-svc/Kimono-SNR.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/Kimono-SNR.cfg	(revision 1032)
+++ branches/SHM-dev/cfg/per-sequence-svc/Kimono-SNR.cfg	(revision 1581)
@@ -13,5 +13,5 @@
 SourceHeight0                 : 1080        # Input  frame height
 RepFormatIdx0                 : 0           # Index of corresponding rep_format() in the VPS
-IntraPeriod0                  : 24          # Period of I-Frame ( -1 = only first)
+IntraPeriod0                  : 32          # Period of I-Frame ( -1 = only first)
 ConformanceMode0              : 1           # conformance mode
 QP0                           : 22
@@ -24,5 +24,5 @@
 SourceHeight1                 : 1080        # Input  frame height
 RepFormatIdx1                 : 0           # Index of corresponding rep_format() in the VPS
-IntraPeriod1                  : 24          # Period of I-Frame ( -1 = only first)
+IntraPeriod1                  : 32          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
 QP1                           : 20
Index: branches/SHM-dev/cfg/per-sequence-svc/ParkScene-1.5x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/ParkScene-1.5x.cfg	(revision 1032)
+++ branches/SHM-dev/cfg/per-sequence-svc/ParkScene-1.5x.cfg	(revision 1581)
@@ -13,5 +13,5 @@
 SourceHeight0                 : 720         # Input  frame height
 RepFormatIdx0                 : 0           # Index of corresponding rep_format() in the VPS
-IntraPeriod0                  : 24          # Period of I-Frame ( -1 = only first)
+IntraPeriod0                  : 32          # Period of I-Frame ( -1 = only first)
 ConformanceMode0              : 1           # conformance mode
 QP0                           : 22
@@ -24,5 +24,5 @@
 SourceHeight1                 : 1080        # Input  frame height
 RepFormatIdx1                 : 1           # Index of corresponding rep_format() in the VPS
-IntraPeriod1                  : 24          # Period of I-Frame ( -1 = only first)
+IntraPeriod1                  : 32          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
 QP1                           : 20
Index: branches/SHM-dev/cfg/per-sequence-svc/ParkScene-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/ParkScene-2x.cfg	(revision 1032)
+++ branches/SHM-dev/cfg/per-sequence-svc/ParkScene-2x.cfg	(revision 1581)
@@ -13,5 +13,5 @@
 SourceHeight0                 : 540         # Input  frame height
 RepFormatIdx0                 : 0           # Index of corresponding rep_format() in the VPS
-IntraPeriod0                  : 24          # Period of I-Frame ( -1 = only first)
+IntraPeriod0                  : 32          # Period of I-Frame ( -1 = only first)
 ConformanceMode0              : 1           # conformance mode
 QP0                           : 22
@@ -24,5 +24,5 @@
 SourceHeight1                 : 1080        # Input  frame height
 RepFormatIdx1                 : 1           # Index of corresponding rep_format() in the VPS
-IntraPeriod1                  : 24          # Period of I-Frame ( -1 = only first)
+IntraPeriod1                  : 32          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
 QP1                           : 20
Index: branches/SHM-dev/cfg/per-sequence-svc/ParkScene-SNR.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/ParkScene-SNR.cfg	(revision 1032)
+++ branches/SHM-dev/cfg/per-sequence-svc/ParkScene-SNR.cfg	(revision 1581)
@@ -13,5 +13,5 @@
 SourceHeight0                 : 1080        # Input  frame height
 RepFormatIdx0                 : 0           # Index of corresponding rep_format() in the VPS
-IntraPeriod0                  : 24          # Period of I-Frame ( -1 = only first)
+IntraPeriod0                  : 32          # Period of I-Frame ( -1 = only first)
 ConformanceMode0              : 1           # conformance mode
 QP0                           : 22
@@ -24,5 +24,5 @@
 SourceHeight1                 : 1080        # Input  frame height
 RepFormatIdx1                 : 0           # Index of corresponding rep_format() in the VPS
-IntraPeriod1                  : 24          # Period of I-Frame ( -1 = only first)
+IntraPeriod1                  : 32          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
 QP1                           : 20