Index: branches/SHM-dev/cfg/encoder_randomaccess_scalable_8_10.cfg
===================================================================
--- branches/SHM-dev/cfg/encoder_randomaccess_scalable_8_10.cfg	(revision 1582)
+++ branches/SHM-dev/cfg/encoder_randomaccess_scalable_8_10.cfg	(revision 1583)
@@ -25,14 +25,22 @@
 #IntraPeriod                   : 32          # Period of I-Frame ( -1 = only first)
 DecodingRefreshType           : 1           # Random Accesss 0:none, 1:CRA, 2:IDR, 3:Recovery Point SEI
-GOPSize                       : 8           # GOP Size (number of B slice = GOPSize-1)
-#        Type POC QPoffset QPfactor tcOffsetDiv2 betaOffsetDiv2 temporal_id #ref_pics_active #ref_pics reference pictures     predict deltaRPS #ref_idcs reference idcs 
-Frame1:  B    8   1        0.442    0            0              0           4                4         -8 -10 -12 -16         0
-Frame2:  B    4   2        0.3536   0            0              0           2                3         -4 -6  4               1       4        5         1 1 0 0 1
-Frame3:  B    2   3        0.3536   0            0              0           2                4         -2 -4  2 6             1       2        4         1 1 1 1  
-Frame4:  B    1   4        0.68     0            0              1           2                4         -1  1  3 7             1       1        5         1 0 1 1 1 
-Frame5:  B    3   4        0.68     0            0              1           2                4         -1 -3  1 5             1      -2        5         1 1 1 1 0
-Frame6:  B    6   3        0.3536   0            0              0           2                4         -2 -4 -6 2             1      -3        5         1 1 1 1 0
-Frame7:  B    5   4        0.68     0            0              1           2                4         -1 -5  1 3             1       1        5         1 0 1 1 1  
-Frame8:  B    7   4        0.68     0            0              1           2                4         -1 -3 -7 1             1      -2        5         1 1 1 1 0
+GOPSize                       : 16           # GOP Size (number of B slice = GOPSize-1)
+#        Type POC QPoffset CbQPoffset CrQPoffset QPfactor tcOffsetDiv2 betaOffsetDiv2 temporal_id #ref_pics_active #ref_pics reference pictures     predict deltaRPS #ref_idcs reference idcs 
+Frame1:  B   16   1        0          0          0.6      0            0              0           2                3         -16 -24 -32            0
+Frame2:  B    8   2        0          0          0.2      0            0              1           2                3         -8  -16   8            1       8        4         1 1 0 1
+Frame3:  B    4   3        0          0          0.33     0            0              2           2                4         -4  -12   4  12        1       4        4         1 1 1 1
+Frame4:  B    2   4        0          0          0.33     0            0              3           2                5         -2  -10   2   6  14    1       2        5         1 1 1 1 1
+Frame5:  B    1   5        0          0          0.4      0            0              4           2                5         -1    1  3    7  15    1       1        6         1 0 1 1 1 1
+Frame6:  B    3   5        0          0          0.4      0            0              4           2                5         -1   -3   1   5  13    1      -2        6         1 1 1 1 1 0
+Frame7:  B    6   4        0          0          0.33     0            0              3           2                4         -2   -6   2  10        1      -3        6         0 1 1 1 1 0
+Frame8:  B    5   5        0          0          0.4      0            0              4           2                5         -1   -5   1   3  11    1       1        5         1 1 1 1 1
+Frame9:  B    7   5        0          0          0.4      0            0              4           2                5         -1   -3  -7   1   9    1      -2        6         1 1 1 1 1 0
+Frame10: B   12   3        0          0          0.33     0            0              2           2                3         -4  -12   4            1      -5        6         0 0 1 1 1 0
+Frame11: B   10   4        0          0          0.33     0            0              3           2                4         -2  -10   2   6        1       2        4         1 1 1 1
+Frame12: B    9   5        0          0          0.4      0            0              4           2                5         -1   -9   1   3   7    1       1        5         1 1 1 1 1
+Frame13: B   11   5        0          0          0.4      0            0              4           2                5         -1   -3 -11   1   5    1      -2        6         1 1 1 1 1 0
+Frame14: B   14   4        0          0          0.33     0            0              3           2                4         -2   -6 -14   2        1      -3        6         0 1 1 1 1 0
+Frame15: B   13   5        0          0          0.4      0            0              4           2                5         -1   -5 -13   1   3    1       1        5         1 1 1 1 1
+Frame16: B   15   5        0          0          0.4      0            0              4           2                5         -1   -3 -7  -15   1    1      -2        6         1 1 1 1 1 0
 
 #=========== Motion Search =============
@@ -53,10 +61,9 @@
 
 #=========== Deblock Filter ============
-DeblockingFilterControlPresent: 0           # Dbl control params present (0=not present, 1=present)
-LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
+LoopFilterOffsetInPPS         : 1           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1 (default) =constant params in PPS, param = base_param)
 LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter)
 LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6
 LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
-DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
+DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream). Applies slice-level loop filter offsets (LoopFilterOffsetInPPS and LoopFilterDisable must be 0)
 
 #=========== Misc. ============