Index: branches/SHM-dev/cfg/encoder_randomaccess_scalable.cfg
===================================================================
--- branches/SHM-dev/cfg/encoder_randomaccess_scalable.cfg	(revision 1592)
+++ branches/SHM-dev/cfg/encoder_randomaccess_scalable.cfg	(revision 1593)
@@ -46,5 +46,5 @@
 #=========== Motion Search =============
 FastSearch                    : 1           # 0:Full search  1:TZ search
-SearchRange                   : 64          # (0: Search range is a Full frame)
+SearchRange                   : 256         # (0: Search range is a Full frame)
 BipredSearchRange             : 4           # Search range for bi-prediction refinement
 HadamardME                    : 1           # Use of hadamard measure for fractional ME
Index: branches/SHM-dev/cfg/encoder_randomaccess_scalable_8_10.cfg
===================================================================
--- branches/SHM-dev/cfg/encoder_randomaccess_scalable_8_10.cfg	(revision 1592)
+++ branches/SHM-dev/cfg/encoder_randomaccess_scalable_8_10.cfg	(revision 1593)
@@ -23,7 +23,7 @@
 
 #======== Coding Structure =============
-#IntraPeriod                   : 32          # Period of I-Frame ( -1 = only first)
+#IntraPeriod                  : 32          # Period of I-Frame ( -1 = only first)
 DecodingRefreshType           : 1           # Random Accesss 0:none, 1:CRA, 2:IDR, 3:Recovery Point SEI
-GOPSize                       : 16           # GOP Size (number of B slice = GOPSize-1)
+GOPSize                       : 16          # GOP Size (number of B slice = GOPSize-1)
 #        Type POC QPoffset CbQPoffset CrQPoffset QPfactor tcOffsetDiv2 betaOffsetDiv2 temporal_id #ref_pics_active #ref_pics reference pictures     predict deltaRPS #ref_idcs reference idcs 
 Frame1:  B   16   1        0          0          0.6      0            0              0           2                3         -16 -24 -32            0
Index: branches/SHM-dev/cfg/misc/layers4.cfg
===================================================================
--- branches/SHM-dev/cfg/misc/layers4.cfg	(revision 1593)
+++ branches/SHM-dev/cfg/misc/layers4.cfg	(revision 1593)
@@ -0,0 +1,63 @@
+NumLayers                     : 2
+NonHEVCBase                   : 0
+ScalabilityMask1              : 0           # Multiview
+ScalabilityMask2              : 1           # Scalable
+ScalabilityMask3              : 0           # Auxiliary pictures
+AdaptiveResolutionChange      : 0           # Resolution change frame (0: disable)
+SkipPictureAtArcSwitch        : 0           # Code higher layer picture as skip at ARC switching (0: disable (default), 1: enable)
+MaxTidRefPresentFlag          : 1           # max_tid_ref_present_flag (0=not present, 1=present(default))
+CrossLayerPictureTypeAlignFlag: 1           # Picture type alignment across layers
+CrossLayerIrapAlignFlag       : 1           # Align IRAP across layers
+SEIDecodedPictureHash         : 1
+
+#============= LAYER 0 ==================
+LayerId0                      : 0
+QP0                           : 22
+MaxTidIlRefPicsPlus10         : 4           # max_tid_il_ref_pics_plus1 for layer0
+#============ Rate Control ==============
+RateControl0                  : 0           # Rate control: enable rate control for layer 0
+TargetBitrate0                : 1000000     # Rate control: target bitrate for layer 0, in bps
+KeepHierarchicalBit0          : 1           # Rate control: keep hierarchical bit allocation for layer 0 in rate control algorithm
+LCULevelRateControl0          : 1           # Rate control: 1: LCU level RC for layer 0; 0: picture level RC for layer 0
+RCLCUSeparateModel0           : 1           # Rate control: use LCU level separate R-lambda model for layer 0
+InitialQP0                    : 0           # Rate control: initial QP for layer 0
+RCForceIntraQP0               : 0           # Rate control: force intra QP to be equal to initial QP for layer 0
+
+#============ WaveFront ================
+WaveFrontSynchro0             : 0           # 0:  No WaveFront synchronisation (WaveFrontSubstreams must be 1 in this case).
+                                            # >0: WaveFront synchronises with the LCU above and to the right by this many LCUs.
+
+#============= LAYER 1 ==================
+LayerId1                      : 4
+QP1                           : 20
+NumSamplePredRefLayers1       : 1           # number of sample pred reference layers
+SamplePredRefLayerIds1        : 0           # reference layer id
+NumMotionPredRefLayers1       : 1           # number of motion pred reference layers
+MotionPredRefLayerIds1        : 0           # reference layer id
+NumActiveRefLayers1           : 1           # number of active reference layers
+PredLayerIds1                 : 0           # inter-layer prediction layer index within available reference layers
+
+#============ Rate Control ==============
+RateControl1                  : 0           # Rate control: enable rate control for layer 1
+TargetBitrate1                : 1000000     # Rate control: target bitrate for layer 1, in bps
+KeepHierarchicalBit1          : 1           # Rate control: keep hierarchical bit allocation for layer 1 in rate control algorithm
+LCULevelRateControl1          : 1           # Rate control: 1: LCU level RC for layer 1; 0: picture level RC for layer 1
+RCLCUSeparateModel1           : 1           # Rate control: use LCU level separate R-lambda model for layer 1
+InitialQP1                    : 0           # Rate control: initial QP for layer 1
+RCForceIntraQP1               : 0           # Rate control: force intra QP to be equal to initial QP for layer 1
+
+#============ WaveFront ================
+WaveFrontSynchro1             : 0           # 0:  No WaveFront synchronisation (WaveFrontSubstreams must be 1 in this case).
+                                            # >0: WaveFront synchronises with the LCU above and to the right by this many LCUs.
+
+NumLayerSets                  : 2           # Include default layer set, value of 0 not allowed
+NumLayerInIdList1             : 2           # 0-th layer set is default, need not specify LayerSetLayerIdList0 or NumLayerInIdList0
+LayerSetLayerIdList1          : 0 4
+
+NumAddLayerSets                      : 0
+NumOutputLayerSets                   : 2           # Include defualt OLS, value of 0 not allowed
+DefaultTargetOutputLayerIdc          : 1
+NumOutputLayersInOutputLayerSet      : 1           # The number of layers in the 0-th OLS should not be specified, 
+# ListOfOutputLayers0 need not be specified
+ListOfOutputLayers1	                 : 4
+ListOfProfileTierLevelOls1           : 1 2
Index: branches/SHM-dev/cfg/misc/layers8.cfg
===================================================================
--- branches/SHM-dev/cfg/misc/layers8.cfg	(revision 1593)
+++ branches/SHM-dev/cfg/misc/layers8.cfg	(revision 1593)
@@ -0,0 +1,122 @@
+NumLayers                     : 8
+NonHEVCBase                   : 0
+ScalabilityMask1              : 0           # Multiview
+ScalabilityMask2              : 1           # Scalable
+ScalabilityMask3              : 0           # Auxiliary pictures
+AdaptiveResolutionChange      : 0           # Resolution change frame (0: disable)
+SkipPictureAtArcSwitch        : 0           # Code higher layer picture as skip at ARC switching (0: disable (default), 1: enable)
+MaxTidRefPresentFlag          : 1           # max_tid_ref_present_flag (0=not present, 1=present(default))
+CrossLayerPictureTypeAlignFlag: 1           # Picture type alignment across layers
+CrossLayerIrapAlignFlag       : 1           # Align IRAP across layers
+SEIDecodedPictureHash         : 1
+
+#============= LAYER 0 ==================
+QP0                           : 22
+MaxTidIlRefPicsPlus10         : 1           # max_tid_il_ref_pics_plus1 for layer0
+InternalBitDepth0             : 8           # codec operating bit-depth for layer 0
+
+#============= LAYER 1 ==================
+QP1                           : 20
+InternalBitDepth1             : 8           # codec operating bit-depth for layer 1
+NumSamplePredRefLayers1       : 1           # number of sample pred reference layers
+SamplePredRefLayerIds1        : 0           # reference layer id
+NumMotionPredRefLayers1       : 1           # number of motion pred reference layers
+MotionPredRefLayerIds1        : 0           # reference layer id
+NumActiveRefLayers1           : 1           # number of active reference layers
+PredLayerIds1                 : 0           # inter-layer prediction layer index within available reference layers
+
+#============= LAYER 2 ==================
+QP2                           : 20
+InternalBitDepth2             : 8           # codec operating bit-depth for layer 1
+NumSamplePredRefLayers2       : 1           # number of sample pred reference layers
+SamplePredRefLayerIds2        : 1           # reference layer id
+NumMotionPredRefLayers2       : 2           # number of motion pred reference layers
+MotionPredRefLayerIds2        : 0 1         # reference layer id
+NumActiveRefLayers2           : 1           # number of active reference layers
+PredLayerIds2                 : 0           # inter-layer prediction layer index within available reference layers
+
+#============= LAYER 3 ==================
+QP3                           : 20
+InternalBitDepth3             : 8           # codec operating bit-depth for layer 1
+NumSamplePredRefLayers3       : 2           # number of sample pred reference layers
+SamplePredRefLayerIds3        : 0 2         # reference layer id
+NumMotionPredRefLayers3       : 1           # number of motion pred reference layers
+MotionPredRefLayerIds3        : 2           # reference layer id
+NumActiveRefLayers3           : 1           # number of active reference layers
+PredLayerIds3                 : 0           # inter-layer prediction layer index within available reference layers
+
+#============= LAYER 4 ==================
+QP4                           : 20
+InternalBitDepth4             : 8           # codec operating bit-depth for layer 1
+NumSamplePredRefLayers4       : 1           # number of sample pred reference layers
+SamplePredRefLayerIds4        : 3           # reference layer id
+NumMotionPredRefLayers4       : 1           # number of motion pred reference layers
+MotionPredRefLayerIds4        : 3           # reference layer id
+NumActiveRefLayers4           : 1           # number of active reference layers
+PredLayerIds4                 : 0           # inter-layer prediction layer index within available reference layers
+
+#============= LAYER 5 ==================
+QP5                           : 20
+InternalBitDepth5             : 8           # codec operating bit-depth for layer 1
+NumSamplePredRefLayers5       : 2           # number of sample pred reference layers
+SamplePredRefLayerIds5        : 0 4         # reference layer id
+NumMotionPredRefLayers5       : 1           # number of motion pred reference layers
+MotionPredRefLayerIds5        : 4           # reference layer id
+NumActiveRefLayers5           : 2           # number of active reference layers
+PredLayerIds5                 : 0 1         # inter-layer prediction layer index within available reference layers
+
+#============= LAYER 6 ==================
+QP6                           : 20
+InternalBitDepth6             : 8           # codec operating bit-depth for layer 1
+NumSamplePredRefLayers6       : 1           # number of sample pred reference layers
+SamplePredRefLayerIds6        : 5           # reference layer id
+NumMotionPredRefLayers6       : 3           # number of motion pred reference layers
+MotionPredRefLayerIds6        : 0 3 4       # reference layer id
+NumActiveRefLayers6           : 2           # number of active reference layers
+PredLayerIds6                 : 0 2         # inter-layer prediction layer index within available reference layers
+
+#============= LAYER 7 ==================
+QP7                           : 20
+InternalBitDepth7             : 8           # codec operating bit-depth for layer 1
+NumSamplePredRefLayers7       : 3           # number of sample pred reference layers
+SamplePredRefLayerIds7        : 1 4 6       # reference layer id
+NumMotionPredRefLayers7       : 3           # number of motion pred reference layers
+MotionPredRefLayerIds7        : 1 5 6       # reference layer id
+NumActiveRefLayers7           : 4           # number of active reference layers
+PredLayerIds7                 : 0 1 2 3     # inter-layer prediction layer index within available reference layers
+
+NumLayerSets                  : 8           # Include default layer set, value of 0 not allowed
+NumLayerInIdList1             : 2           # 0-th layer set is default, need not specify LayerSetLayerIdList0 or NumLayerInIdList0
+LayerSetLayerIdList1          : 0 1
+NumLayerInIdList2             : 3
+LayerSetLayerIdList2          : 0 1 2
+NumLayerInIdList3             : 4
+LayerSetLayerIdList3          : 0 1 2 3
+NumLayerInIdList4             : 5
+LayerSetLayerIdList4          : 0 1 2 3 4
+NumLayerInIdList5             : 6
+LayerSetLayerIdList5          : 0 1 2 3 4 5
+NumLayerInIdList6             : 7
+LayerSetLayerIdList6          : 0 1 2 3 4 5 6
+NumLayerInIdList7             : 8
+LayerSetLayerIdList7          : 0 1 2 3 4 5 6 7
+
+NumAddLayerSets                      : 0
+NumOutputLayerSets                   : 8           # Include defualt OLS, value of 0 not allowed
+DefaultTargetOutputLayerIdc          : 1
+NumOutputLayersInOutputLayerSet      : 1 1 1 1 1 1 1          # The number of layers in the 0-th OLS should not be specified, 
+# ListOfOutputLayers0 need not be specified
+ListOfOutputLayers1	                 : 1
+ListOfProfileTierLevelOls1           : 1 2
+ListOfOutputLayers2	                 : 2
+ListOfProfileTierLevelOls2           : 1 2 2
+ListOfOutputLayers3	                 : 3
+ListOfProfileTierLevelOls3           : 1 2 2 2
+ListOfOutputLayers4	                 : 4
+ListOfProfileTierLevelOls4           : 1 2 2 2 2
+ListOfOutputLayers5	                 : 5
+ListOfProfileTierLevelOls5           : 1 2 2 2 2 2
+ListOfOutputLayers6	                 : 6
+ListOfProfileTierLevelOls6           : 1 2 2 2 2 2 2
+ListOfOutputLayers7	                 : 7
+ListOfProfileTierLevelOls7           : 1 2 2 2 2 2 2 2
Index: branches/SHM-dev/cfg/scalable_rext/depth_scalability_400/encoder_randomaccess_scalable_Monochrome8_12.cfg
===================================================================
--- branches/SHM-dev/cfg/scalable_rext/depth_scalability_400/encoder_randomaccess_scalable_Monochrome8_12.cfg	(revision 1592)
+++ branches/SHM-dev/cfg/scalable_rext/depth_scalability_400/encoder_randomaccess_scalable_Monochrome8_12.cfg	(revision 1593)
@@ -25,18 +25,26 @@
 #IntraPeriod                   : 32          # Period of I-Frame ( -1 = only first)
 DecodingRefreshType           : 1           # Random Accesss 0:none, 1:CRA, 2:IDR, 3:Recovery Point SEI
-GOPSize                       : 8           # GOP Size (number of B slice = GOPSize-1)
-#        Type POC QPoffset QPfactor tcOffsetDiv2 betaOffsetDiv2 temporal_id #ref_pics_active #ref_pics reference pictures     predict deltaRPS #ref_idcs reference idcs 
-Frame1:  B    8   1        0.442    0            0              0           4                4         -8 -10 -12 -16         0
-Frame2:  B    4   2        0.3536   0            0              0           2                3         -4 -6  4               1       4        5         1 1 0 0 1
-Frame3:  B    2   3        0.3536   0            0              0           2                4         -2 -4  2 6             1       2        4         1 1 1 1  
-Frame4:  B    1   4        0.68     0            0              1           2                4         -1  1  3 7             1       1        5         1 0 1 1 1 
-Frame5:  B    3   4        0.68     0            0              1           2                4         -1 -3  1 5             1      -2        5         1 1 1 1 0
-Frame6:  B    6   3        0.3536   0            0              0           2                4         -2 -4 -6 2             1      -3        5         1 1 1 1 0
-Frame7:  B    5   4        0.68     0            0              1           2                4         -1 -5  1 3             1       1        5         1 0 1 1 1  
-Frame8:  B    7   4        0.68     0            0              1           2                4         -1 -3 -7 1             1      -2        5         1 1 1 1 0
+GOPSize                       : 16           # GOP Size (number of B slice = GOPSize-1)
+#        Type POC QPoffset CbQPoffset CrQPoffset QPfactor tcOffsetDiv2 betaOffsetDiv2 temporal_id #ref_pics_active #ref_pics reference pictures     predict deltaRPS #ref_idcs reference idcs 
+Frame1:  B   16   1        0          0          0.6      0            0              0           2                3         -16 -24 -32            0
+Frame2:  B    8   2        0          0          0.2      0            0              1           2                3         -8  -16   8            1       8        4         1 1 0 1
+Frame3:  B    4   3        0          0          0.33     0            0              2           2                4         -4  -12   4  12        1       4        4         1 1 1 1
+Frame4:  B    2   4        0          0          0.33     0            0              3           2                5         -2  -10   2   6  14    1       2        5         1 1 1 1 1
+Frame5:  B    1   5        0          0          0.4      0            0              4           2                5         -1    1  3    7  15    1       1        6         1 0 1 1 1 1
+Frame6:  B    3   5        0          0          0.4      0            0              4           2                5         -1   -3   1   5  13    1      -2        6         1 1 1 1 1 0
+Frame7:  B    6   4        0          0          0.33     0            0              3           2                4         -2   -6   2  10        1      -3        6         0 1 1 1 1 0
+Frame8:  B    5   5        0          0          0.4      0            0              4           2                5         -1   -5   1   3  11    1       1        5         1 1 1 1 1
+Frame9:  B    7   5        0          0          0.4      0            0              4           2                5         -1   -3  -7   1   9    1      -2        6         1 1 1 1 1 0
+Frame10: B   12   3        0          0          0.33     0            0              2           2                3         -4  -12   4            1      -5        6         0 0 1 1 1 0
+Frame11: B   10   4        0          0          0.33     0            0              3           2                4         -2  -10   2   6        1       2        4         1 1 1 1
+Frame12: B    9   5        0          0          0.4      0            0              4           2                5         -1   -9   1   3   7    1       1        5         1 1 1 1 1
+Frame13: B   11   5        0          0          0.4      0            0              4           2                5         -1   -3 -11   1   5    1      -2        6         1 1 1 1 1 0
+Frame14: B   14   4        0          0          0.33     0            0              3           2                4         -2   -6 -14   2        1      -3        6         0 1 1 1 1 0
+Frame15: B   13   5        0          0          0.4      0            0              4           2                5         -1   -5 -13   1   3    1       1        5         1 1 1 1 1
+Frame16: B   15   5        0          0          0.4      0            0              4           2                5         -1   -3 -7  -15   1    1      -2        6         1 1 1 1 1 0
 
 #=========== Motion Search =============
 FastSearch                    : 1           # 0:Full search  1:TZ search
-SearchRange                   : 64          # (0: Search range is a Full frame)
+SearchRange                   : 256         # (0: Search range is a Full frame)
 BipredSearchRange             : 4           # Search range for bi-prediction refinement
 HadamardME                    : 1           # Use of hadamard measure for fractional ME
@@ -45,7 +53,7 @@
 
 #======== Quantization =============
-#QP                            : 32          # Quantization parameter(0-51)
+#QP                           : 32          # Quantization parameter(0-51)
 MaxDeltaQP                    : 0           # CU-based multi-QP optimization
-#MaxCuDQPDepth                 : 0           # Max depth of a minimum CuDQP for sub-LCU-level delta QP
+#MaxCuDQPDepth                : 0           # Max depth of a minimum CuDQP for sub-LCU-level delta QP
 DeltaQpRD                     : 0           # Slice-based multi-QP optimization
 RDOQ                          : 1           # RDOQ
Index: branches/SHM-dev/cfg/scalable_rext/spatial_scalability_444/encoder_randomaccess_scalable_Main_444.cfg
===================================================================
--- branches/SHM-dev/cfg/scalable_rext/spatial_scalability_444/encoder_randomaccess_scalable_Main_444.cfg	(revision 1592)
+++ branches/SHM-dev/cfg/scalable_rext/spatial_scalability_444/encoder_randomaccess_scalable_Main_444.cfg	(revision 1593)
@@ -23,20 +23,28 @@
 
 #======== Coding Structure =============
-#IntraPeriod                   : 32          # Period of I-Frame ( -1 = only first)
+#IntraPeriod                  : 32          # Period of I-Frame ( -1 = only first)
 DecodingRefreshType           : 1           # Random Accesss 0:none, 1:CRA, 2:IDR, 3:Recovery Point SEI
-GOPSize                       : 8           # GOP Size (number of B slice = GOPSize-1)
-#        Type POC QPoffset QPfactor tcOffsetDiv2 betaOffsetDiv2 temporal_id #ref_pics_active #ref_pics reference pictures     predict deltaRPS #ref_idcs reference idcs 
-Frame1:  B    8   1        0.442    0            0              0           4                4         -8 -10 -12 -16         0
-Frame2:  B    4   2        0.3536   0            0              0           2                3         -4 -6  4               1       4        5         1 1 0 0 1
-Frame3:  B    2   3        0.3536   0            0              0           2                4         -2 -4  2 6             1       2        4         1 1 1 1  
-Frame4:  B    1   4        0.68     0            0              1           2                4         -1  1  3 7             1       1        5         1 0 1 1 1 
-Frame5:  B    3   4        0.68     0            0              1           2                4         -1 -3  1 5             1      -2        5         1 1 1 1 0
-Frame6:  B    6   3        0.3536   0            0              0           2                4         -2 -4 -6 2             1      -3        5         1 1 1 1 0
-Frame7:  B    5   4        0.68     0            0              1           2                4         -1 -5  1 3             1       1        5         1 0 1 1 1  
-Frame8:  B    7   4        0.68     0            0              1           2                4         -1 -3 -7 1             1      -2        5         1 1 1 1 0
+GOPSize                       : 16          # GOP Size (number of B slice = GOPSize-1)
+#        Type POC QPoffset CbQPoffset CrQPoffset QPfactor tcOffsetDiv2 betaOffsetDiv2 temporal_id #ref_pics_active #ref_pics reference pictures     predict deltaRPS #ref_idcs reference idcs 
+Frame1:  B   16   1        0          0          0.6      0            0              0           2                3         -16 -24 -32            0
+Frame2:  B    8   2        0          0          0.2      0            0              1           2                3         -8  -16   8            1       8        4         1 1 0 1
+Frame3:  B    4   3        0          0          0.33     0            0              2           2                4         -4  -12   4  12        1       4        4         1 1 1 1
+Frame4:  B    2   4        0          0          0.33     0            0              3           2                5         -2  -10   2   6  14    1       2        5         1 1 1 1 1
+Frame5:  B    1   5        0          0          0.4      0            0              4           2                5         -1    1  3    7  15    1       1        6         1 0 1 1 1 1
+Frame6:  B    3   5        0          0          0.4      0            0              4           2                5         -1   -3   1   5  13    1      -2        6         1 1 1 1 1 0
+Frame7:  B    6   4        0          0          0.33     0            0              3           2                4         -2   -6   2  10        1      -3        6         0 1 1 1 1 0
+Frame8:  B    5   5        0          0          0.4      0            0              4           2                5         -1   -5   1   3  11    1       1        5         1 1 1 1 1
+Frame9:  B    7   5        0          0          0.4      0            0              4           2                5         -1   -3  -7   1   9    1      -2        6         1 1 1 1 1 0
+Frame10: B   12   3        0          0          0.33     0            0              2           2                3         -4  -12   4            1      -5        6         0 0 1 1 1 0
+Frame11: B   10   4        0          0          0.33     0            0              3           2                4         -2  -10   2   6        1       2        4         1 1 1 1
+Frame12: B    9   5        0          0          0.4      0            0              4           2                5         -1   -9   1   3   7    1       1        5         1 1 1 1 1
+Frame13: B   11   5        0          0          0.4      0            0              4           2                5         -1   -3 -11   1   5    1      -2        6         1 1 1 1 1 0
+Frame14: B   14   4        0          0          0.33     0            0              3           2                4         -2   -6 -14   2        1      -3        6         0 1 1 1 1 0
+Frame15: B   13   5        0          0          0.4      0            0              4           2                5         -1   -5 -13   1   3    1       1        5         1 1 1 1 1
+Frame16: B   15   5        0          0          0.4      0            0              4           2                5         -1   -3 -7  -15   1    1      -2        6         1 1 1 1 1 0
 
 #=========== Motion Search =============
 FastSearch                    : 1           # 0:Full search  1:TZ search
-SearchRange                   : 64          # (0: Search range is a Full frame)
+SearchRange                   : 256         # (0: Search range is a Full frame)
 BipredSearchRange             : 4           # Search range for bi-prediction refinement
 HadamardME                    : 1           # Use of hadamard measure for fractional ME